BEFProfessions = {};
BEFProfessions.DoTraits = function()
    TraitFactory.addTrait("new_KeenHearing", getText("UI_trait_keenhearing"), 0, getText("UI_trait_keenhearingdesc"), true);
    TraitFactory.addTrait("new_Cowardly", getText("UI_trait_cowardly"), 0, getText("UI_trait_cowardlydesc"), true);
    TraitFactory.addTrait("new_EagleEyed", getText("UI_trait_eagleeyed"), 0, getText("UI_trait_eagleeyeddesc"), true);
    TraitFactory.addTrait("new_Outdoorsman", getText("UI_trait_outdoorsman"), 0, getText("UI_trait_outdoorsmandesc"), true);
    TraitFactory.addTrait("new_FastReader", getText("UI_trait_FastReader"), 0, getText("UI_trait_FastReaderDesc"), true);
    TraitFactory.addTrait("new_Organized", getText("UI_trait_Packmule"), 0, getText("UI_trait_PackmuleDesc"), true);
    TraitFactory.addTrait("new_Pacifist", getText("UI_trait_Pacifist"), 0, getText("UI_trait_PacifistDesc"), true);
    TraitFactory.addTrait("new_Brave", getText("UI_trait_brave"), 0, getText("UI_trait_bravedesc"), true);

	local new_OutofShape = TraitFactory.addTrait("new_OutofShape", getText("UI_trait_outofshape"), 0, getText("UI_trait_outofshapedesc"), true);
	new_OutofShape:addXPBoost(Perks.Fitness, -2);
    local new_Strong = TraitFactory.addTrait("new_Strong", getText("UI_trait_strong"), 0, getText("UI_trait_strongdesc"), true);
    new_Strong:addXPBoost(Perks.Strength, 4);
    local new_Stout = TraitFactory.addTrait("new_Stout", getText("UI_trait_stout"), 0, getText("UI_trait_stoutdesc"), true);
    new_Stout:addXPBoost(Perks.Strength, 2);
    local new_Feeble = TraitFactory.addTrait("new_Feeble", getText("UI_trait_feeble"), 0, getText("UI_trait_feebledesc"), true);
    new_Feeble:addXPBoost(Perks.Strength, -2);
end
BEFProfessions.DoProfessions = function()
	local maintenanceworker = ProfessionFactory.addProfession(
		"prof_maintenanceworker",
		"Maintenance Worker",
		"profession_maintenanceworker",
		-8,
		"Also known as repair workers, fix and maintain mechanical equipment, buildings, and machines. Bonus task to stay alive."
	);
	maintenanceworker:addXPBoost(Perks.Fitness, -1);
	maintenanceworker:addXPBoost(Perks.Strength, -1);
	maintenanceworker:addXPBoost(Perks.Blunt, 1);
	maintenanceworker:addXPBoost(Perks.SmallBlunt, 1);
	maintenanceworker:addXPBoost(Perks.Maintenance, 1);
	maintenanceworker:addXPBoost(Perks.Woodwork, 1);
	maintenanceworker:addXPBoost(Perks.Electricity, 1);
	maintenanceworker:addXPBoost(Perks.MetalWelding, 1);
	maintenanceworker:addXPBoost(Perks.Mechanics, 1);

	local butler = ProfessionFactory.addProfession (
		"prof_butler",
		"Butler",
		"profession_butler",
		-6,
		"In the popular imagination, the word “butler” tends to bring to mind a respectable middle-aged man in a tailcoat holding a silver platter. Time to serve his own life"
	);
	butler:addXPBoost(Perks.Fitness, -1);
	butler:addXPBoost(Perks.Strength, -1);
	butler:addXPBoost(Perks.Lightfoot, 1);
	butler:addXPBoost(Perks.Nimble, 1);
	butler:addXPBoost(Perks.Maintenance, 1);
	butler:addXPBoost(Perks.Cooking, 2);
	butler:addXPBoost(Perks.Doctor, 1);
	butler:addXPBoost(Perks.Tailoring, 1);
	butler:addXPBoost(Perks.SmallBlade, 1);
	
	local bodyguard = ProfessionFactory.addProfession (
		"prof_bodyguard",
		"Body Guard",
		"profession_bodyguard",
		-12,
		"A bodyguard provides personal protection for a client, keeping them safe from physical threats like assault, theft, kidnapping, or assassination. Can he protect himself?"
	);
	bodyguard:addXPBoost(Perks.Fitness, 1);
	bodyguard:addXPBoost(Perks.Strength, 1);
	bodyguard:addXPBoost(Perks.Sprinting, 1);
	bodyguard:addXPBoost(Perks.Nimble, 1);
	bodyguard:addXPBoost(Perks.Aiming, 1);
	bodyguard:addXPBoost(Perks.Reloading, 1);
	bodyguard:addXPBoost(Perks.Blunt, 1);
	bodyguard:addXPBoost(Perks.SmallBlunt, 1);
	bodyguard:addXPBoost(Perks.SmallBlade, 1);

	local mechanicalengineer = ProfessionFactory.addProfession (
		"prof_mechanicalengineer",
		"Mechanical Engineer",
		"profession_mechanicalengineer",
		-8,
		"Mechanical engineers can work on components and equipment for many industries including healthcare, power, transport and water. Time for creativity."
	);
	mechanicalengineer:addXPBoost(Perks.Fitness, -1);
	mechanicalengineer:addXPBoost(Perks.Strength, -1);
	mechanicalengineer:addXPBoost(Perks.Maintenance, 2);
	mechanicalengineer:addXPBoost(Perks.Electricity, 2);
	mechanicalengineer:addXPBoost(Perks.MetalWelding, 2);
	mechanicalengineer:addXPBoost(Perks.Mechanics, 2);
	
	local hermit = ProfessionFactory.addProfession (
		"prof_hermit",
		"Hermit",
		"profession_hermit",
		-12,
		"Like living solo, alone in the woods, up in a mountain, or sometimes they live in a city without hardly ever leaving their apartment. Meh."
	);
	hermit:addXPBoost(Perks.Fishing, 1);
	hermit:addXPBoost(Perks.Trapping, 1);
	hermit:addXPBoost(Perks.PlantScavenging, 1);
	hermit:addXPBoost(Perks.Sprinting, 1);
	hermit:addXPBoost(Perks.Nimble, 1);
	hermit:addXPBoost(Perks.Sneak, 1);
	hermit:addXPBoost(Perks.Cooking, 1);
	hermit:addXPBoost(Perks.Farming, 1);
	hermit:addXPBoost(Perks.Tailoring, 1);
	hermit:addXPBoost(Perks.Maintenance, 1);
	
	local prisoner = ProfessionFactory.addProfession (
		"prof_prisoner",
		"Prisoner",
		"profession_prisoner",
		-10,
		"A person held in custody, captivity, or a condition of forcible restraint, especially while on trial or serving a prison sentence. Nothing will held him now."
	);
	prisoner:addXPBoost(Perks.Sprinting, 1);
	prisoner:addXPBoost(Perks.Nimble, 1);
	prisoner:addXPBoost(Perks.Sneak, 1);
	prisoner:addXPBoost(Perks.Blunt, 1);
	prisoner:addXPBoost(Perks.SmallBlunt, 1);
	prisoner:addXPBoost(Perks.LongBlade, 1);
	prisoner:addXPBoost(Perks.SmallBlade, 1);
	prisoner:addXPBoost(Perks.Lightfoot, 1);

	local botanist = ProfessionFactory.addProfession (
		"prof_botanist",
		"Botanist",
		"profession_botanist",
		-2,
		"A botanist is a highly educated and skilled scientist who studies plant life and organisms, and maybe zombies."
	);
	botanist:addXPBoost(Perks.Fitness, -1);
	botanist:addXPBoost(Perks.Strength, -1);
	botanist:addXPBoost(Perks.Cooking, 2);
	botanist:addXPBoost(Perks.Farming, 2);
	botanist:addXPBoost(Perks.Doctor, 2);

	local freelancer = ProfessionFactory.addProfession (
		"prof_freelancer",
		"Freelancer",
		"profession_freelancer",
		20,
		"Decide his fate, he sacrificed his physical state in order to produce a much greater benefit in skill."
	);
	freelancer:addXPBoost(Perks.Fitness, -1);
	freelancer:addXPBoost(Perks.Strength, -1);

	local armsdealer = ProfessionFactory.addProfession (
		"prof_armsdealer",
		"Arms Dealer",
		"profession_armsdealer",
		-8,
		"Salesman, experienced in every weapon he sell. Time to use it."
	);
	armsdealer:addXPBoost(Perks.Fitness, -1);
	armsdealer:addXPBoost(Perks.Strength, -1);
	armsdealer:addXPBoost(Perks.Axe, 1);
	armsdealer:addXPBoost(Perks.Blunt, 1);
	armsdealer:addXPBoost(Perks.SmallBlunt, 1);
	armsdealer:addXPBoost(Perks.LongBlade, 1);
	armsdealer:addXPBoost(Perks.SmallBlade, 1);
	armsdealer:addXPBoost(Perks.Spear, 1);
	armsdealer:addXPBoost(Perks.Maintenance, 1);

	local courier = ProfessionFactory.addProfession (
		"prof_courier",
		"Courier",
		"profession_courier",
		4,
		"Once responsible for distributing packages and documents for institutions, businesses, government agencies, and individuals. Keep running."
	);
	courier:addXPBoost(Perks.Strength, -1);
	courier:addXPBoost(Perks.Sprinting, 1);
	courier:addXPBoost(Perks.Nimble, 1);

	local janitor = ProfessionFactory.addProfession (
		"prof_janitor",
		"Janitor",
		"profession_janitor",
		4,
		"Perform heavy cleaning duties, such as cleaning floors, shampooing rugs, washing walls and glass, and removing rubbish. Nothing to see here, keep going."
	);
	janitor:addXPBoost(Perks.Nimble, 1);
	janitor:addXPBoost(Perks.Spear, 1);
	janitor:addXPBoost(Perks.PlantScavenging, 1);

	local homekeeper = ProfessionFactory.addProfession (
		"prof_homekeeper",
		"Home Keeper",
		"profession_homekeeper",
		4,
		"Handle light cleaning needed for the upkeep of homes as well as commercial buildings, such as offices, hotels, hospitals and now, outdoors."
	);
	homekeeper:addXPBoost(Perks.Fitness, -1);
	homekeeper:addXPBoost(Perks.Strength, -1);
	homekeeper:addXPBoost(Perks.PlantScavenging, 1);
	homekeeper:addXPBoost(Perks.Maintenance, 1);
	homekeeper:addXPBoost(Perks.Cooking, 1);
	homekeeper:addXPBoost(Perks.Tailoring, 1);

	local driver = ProfessionFactory.addProfession (
		"prof_driver",
		"Driver",
		"profession_driver",
		-2,
		"Undertake various transporting duties, cargo, stash, people, corpses."
	);
	driver:addXPBoost(Perks.Fitness, -1);
	driver:addXPBoost(Perks.Electricity, 1);
	driver:addXPBoost(Perks.Mechanics, 2);

	local baseballplayer = ProfessionFactory.addProfession (
		"prof_baseballplayer",
		"Baseball Player",
		"profession_baseballplayer",
		-4,
		"A baseball player plays baseball. Bet you could have guessed that. Time to play."
	);
	baseballplayer:addXPBoost(Perks.Blunt, 2);
	baseballplayer:addXPBoost(Perks.Maintenance, 1);
	baseballplayer:addXPBoost(Perks.Sprinting, 1);

	local plumber = ProfessionFactory.addProfession (
		"prof_plumber",
		"Plumber",
		"profession_plumber",
		-4,
		"Interprets blueprints and building specifications to map layout for pipes, drainage systems, and other plumbing materials. Still useful."
	);
	plumber:addXPBoost(Perks.Fitness, -1);
	plumber:addXPBoost(Perks.SmallBlunt, 1);
	plumber:addXPBoost(Perks.Maintenance, 1);
	plumber:addXPBoost(Perks.Woodwork, 1);
	plumber:addXPBoost(Perks.MetalWelding, 1);
	
	local systemadministrator = ProfessionFactory.addProfession (
		"prof_systemadministrator",
		"System Administrator",
		"profession_systemadministrator",
		-4,
		"Involves ensuring that the peripheral systems are in proper working condition. Same as for himself."
	);
	systemadministrator:addXPBoost(Perks.Fitness, -1);
	systemadministrator:addXPBoost(Perks.Maintenance, 1);
	systemadministrator:addXPBoost(Perks.Electricity, 2);
	systemadministrator:addXPBoost(Perks.Woodwork, 1);

    local profList = ProfessionFactory.getProfessions()
    for i = 1, profList:size() do
        local profession = profList:get(i - 1);
        BaseGameCharacterDetails.SetProfessionDescription(profession);
        print("Loaded Profesion: " .. profession:getName());
    end
    print("Loaded " .. profList:size() .. " professions!");
    
end

Events.OnGameBoot.Add(BEFProfessions.DoTraits);
Events.OnGameBoot.Add(BEFProfessions.DoProfessions);